public class Chi{

   static double density(double x)
         {
                return Math.exp(-x*x/2.)/Math.sqrt(2*Math.PI);                                                          
         }
   
   static double normale(double x)
         {
                if (x == 0)
                  return 1/2.;
                else if (x > 0)
                  {     double z = 1/(1 + 0.2316419*x);
                  return 1 - density(x)* (0.319381530 *z - 0.356563782* Math.pow(z,2) + 1.781477937 *Math.pow(z,3) - 1.821255978 *Math.pow(z,4) + 1.330274429 *Math.pow(z,5));
                  }
                
                else
                  return 1 - normale(-x);
         }

    

   static double pochisq(double x, int d) {
	   
	if (d % 2 == 0)
		 {
			/* degré pair 
			 * e^(-x/2) * (1+somme x^{r}/2*4*...2r)*/
			double sum = 1;
			double factor = 1;
			for (int i = 1; i <= (d-2)/2; i++)
			  {
				 factor = (factor * x) / (2*i);
				 sum  += factor;
			  }
			return Math.exp(-x/2) * sum;
		 }
	else
		 {
			/* degré impair */
			/* 2 (1-normale(sqrt(x))) + sqrt(2*x/pi) exp(-x/2) somme (x^r / 1*3*..2r+1)*/
			double sum = 1;
			if (d == 1) sum = 0;
			double factor = 1;
			for (int i = 1; i < (d-1)/2; i++)
			  {
				 factor = (factor * x) / (2*i+1);
				 sum  += factor;
			  }
			
			return 2*(1-normale(Math.sqrt(x))) + Math.sqrt(2*x/Math.PI) * Math.exp(-x/2) * sum;
		 }
	   
    }
   

   static double critique(double p, int deg) {
	   double hi = 99999.0;
	   double lo = 0;
	  
	  double chisqval;
	
	if (p <= 0.0) {
	    return hi;
	} else if (p >= 1.0) {
	    return 0.0;
	}
   
	while ((hi - lo) > 0.00001) {
	   double mid = (hi +lo)/2;
	   if (pochisq(mid, deg) < p) 
		 hi = mid;
	   else
		 lo = mid;
	}
	return hi;  
   }
   


}
